# 09/07/2023 Fiaschi Francesco
# shrelo è un nome dervato dalle prime due lettere
# dei tre comandi: Sh-utdown, Re-boot e Lo-gout
# versione OOP

import tkinter as tk
import os
import subprocess

class Application(tk.Frame):

    
    def __init__(self, master=None):
        super().__init__(master)
        self.master=master
        self.master.resizable(width=False, height=False)
        self.master.overrideredirect(True)
        self.pack()
        self.create_widgets()

    def Shutdown(self):
        subprocess.run(["systemctl", "poweroff"])

    def Restart(self):
        subprocess.run(["systemctl", "reboot"])

    def Suspend(self):
        subprocess.run(["systemctl", "suspend"])

    def Hibernate(self):
        subprocess.run(["systemctl", "hibernate"])

    def Logout(self):
        subprocess.run(["openbox", "--exit"])

    def Cancel(self):
        self.master.destroy()
        
    def create_widgets(self):
        self.btn_Shutdown=tk.Button(root, text="", image=img_shutdown, command=self.Shutdown)
        self.btn_Shutdown.pack(side=tk.LEFT) 

        self.btn_Restart=tk.Button(root, text="", image=img_restart, command=self.Restart)
        self.btn_Restart.pack(side=tk.LEFT)

        self.btn_Suspend=tk.Button(root, text="", image=img_suspend, command=self.Suspend)
        self.btn_Suspend.pack(side=tk.LEFT)

        self.btn_hibernate=tk.Button(root, text="", image=img_hibernate, command=self.Hibernate)
        self.btn_hibernate.pack(side=tk.LEFT)

        self.btn_logout=tk.Button(root, text="", image=img_logout, command=self.Logout)
        self.btn_logout.pack(side=tk.LEFT)

        self.btn_Cancel=tk.Button(root, text="", image=img_cancel, command=self.Cancel )
        self.btn_Cancel.pack(side=tk.LEFT)

root=tk.Tk()
img_shutdown = tk.PhotoImage(file = "~/Shrelo/Immagini/shutdown.png")
img_restart = tk.PhotoImage(file = "~/Shrelo/Immagini/restart.png")
img_suspend = tk.PhotoImage(file = "~/Shrelo/Immagini/suspend.png")
img_hibernate = tk.PhotoImage(file = "~/Shrelo/Immagini/hibernate.png")
img_logout = tk.PhotoImage(file = "~/Shrelo/Immagini/logout.png")
img_cancel = tk.PhotoImage(file = "~/Shrelo/Immagini/cancel.png")

app=Application(master=root)
root.update()

# dimensioni schermo
l=root.winfo_screenwidth()
h=root.winfo_screenheight()

# dimensioni finestra
lf=root.winfo_width()
hf=root.winfo_height()

# coordinate punto di disegno finestra
x=int((l-lf)/2)
y=int((h-hf)/2)
root.geometry('{}x{}+{}+{}'.format(lf, hf, x, y))

app.mainloop()
